.TH STIM 4L "January 30, 1991"
.SH NAME
STIM \- SPARCstation Telephone Interface Module.
.SH SYNOPSIS
(none)
.SH DESCRIPTION
.I STIM
is the telephone interface portion of PhoneStation, for the Sun SPARCstation
(the host).
It is capable of hook switch manipulation, touch tone detection,
loop current monitoring, and extension phone detection.
It is controlled through an RS-232 serial port, usually set up
as for a modem,
to handle both incoming and outgoing calls (see zs(4)).
The baud rate is 9600 baud.
In addition to the serial port, the
.I STIM
also has audio input and output connectors, that are connected to the
SPARCstation audio, an rj-11 compatible jack to connect
to the telephone line, and three lights (leds).
.LP
The 
.I power
led is lit to indicate power is applied to the STIM.
The
.I squelch
led
lights whenever the level of the signal to be placed on the phone line
exceeds the FCC prescribed maximum.
The
.I status
led flashes and blinks differently, depending upon the state of the STIM
box.
In the quiescent (on-hook) state, the 
.I status
led 
functions as a "heartbeat", lighting briefly every couple of seconds.
There are two different heartbeat patterns, which are controlled by
the "C" and "c" commands described below.
When an incoming ring is detected, the
light flashes rapidly.
Finally, when the STIM has the phone line off-hook, the status led lights
steadily.
.LP
.I STIM
responds to the following single letter commands:
\& 'C', 'c', 'D','d','E','e','F','H','h','L','l','R','S','s','V','X', and '?'.
For all but 'V', 'X',  and '?', 
.I STIM
responds with either a 'Y', if the operation was successful, or a 'N'
if it was not.  In all cases, every response from 
.I STIM
is followed by a return-linefeed ( '\er' '\en') pair.
The operation of the commands are as follows:
.TP
C
Set the on-hook heartbeat rate to
.I fast.
 The signal light blinks on about
once per second.
.TP
c
Set the on-hook blink rate to
.I slow.
 The signal light blinks on about
once every three seconds.  This is the default.
.TP
D
Turn on Data Carrier Detect (DCD).
This is done automatically when ringing commences.
.TP
d
Turn off Data Carrier Detect (DCD).
Depending on the state of the configuration switches, this can 
happen automatically when the calling party disconnects.
Care must be taken when using 'd', as Unix may refuse to accept any more
data from STIM when DCD is de-asserted.
.TP
E
Enable hardware touch-tone detection while the phone is off-hook.
.TP
e
Disable hardware touch-tone detection.
.TP
F
Simulate a flash hook.  If the phone is off-hook, it is placed in an on-hook
state for several hundred ms, then taken back off hook.
.TP
H
Take the phone off-hook.
If ringing is currently in progress, 
.I STIM
waits for ringing to cease before placing the phone off-hook,
to prolong the life of the switch-hook relay.
.TP
h
Put the phone on-hook.
The loop current detection is disabled, and the relays are reset to their
pass through state.
.TP
L
Enable loop current detection, which senses the loss of loop current, such
as when the calling party hangs up.  Loop current detection is normally
enabled when receiving a call, and disabled when initiating a call.
.TP
l
Disable loop current detection, which senses the loss of loop current, such
as when the calling party hangs up.  Loop current detection is normally
enabled when receiving a call, and disabled when initiating a call.
.TP
R
Resets the phone interface to the default state:
DCD off, touch-tone detection disabled,
loop current monitoring disabled, and on-hook.
.TP
S
Enable squelch detection.  When the audio transmitted onto the phone line
exceeds -9dbm, the output is squelched, the squelch light is lit, and an
"S" is sent to the host.  When the signal to output on the telephone line
drops below -9dbm, the squelch light is extinguished, and an "s" is sent
to the host.  Squelch enable is normally used only to calibrate the
signal levels.
.TP
s
Disable squelch detection.  No indication of transmit squelch is sent to the
host, even though the squelch light and function are still operational.
.TP
V
A line of text indicating the version of the software
is displayed.
.TP
X
An 'X' is echoed back to the host.
'X' can be used to synchronize messages with a host computer.
.TP
?
.I STIM
returns the current state of the phone interface, in the form 
represented by the regular expression 
.B A[Dd][Hh][Rr][Ee][Ll][Ss].
The 'D', 'H', 'R', 'E' 'L' and 'S' represent DCD, hook-state, Ringing
touch tone detection enable loop detection, and squelch
status respectively.
A capital letter means
ON, a lower case letter means OFF.
.LP
In addition the commands described above, several messages are sent by
.I STIM
asynchronously.
While in the on-hook state, when ringing commences, an "R"
is sent.  When ringing stops (normally 2 seconds later), 
.I STIM
sends an "r".
DCD is automatically asserted just before the first "R" is sent.
This permits an answering machine program to "hang" on a device open
until a call arrives, but still permit a separate process to place
an outgoing call.
If loop detection 'L' is enabled, 
when the calling party disconnects, STIM will
send the letter 'd' for disconnect, 
hang up 
the phone line (i.e. place it in the on hook state),
and optionally de-assert DCD.  
STIM examines switch D7 on the controller board.  If the switch is off
(on is the default),
STIM de-asserts DCD.
If call progress monitoring is enabled, 
.I STIM
sends the letter 'P' when a progress tone is detected, and a 'p'
when it goes away.
.LP
.I STIM
will do hardware touch tone detection
when the phone is off-hook, and touch tone detection is enabled.
Any time a valid tone is recognized, its corresponding character
is sent out the serial port.  The characters are one of:
"123456789*0#ABCD", where "ABCD" represent the additional tones not
not available on ordinary phones.
.LP
.I STIM
has two audio connectors labeled IN and OUT.
The IN should be attached to the SPARCstation audio output, and the
OUT to the SPARCstation audio input.
.SH FILES
.TP
/dev/answer
serial port for incoming calls.
.TP
/dev/call
serial port for outgoing calls.
.TP
/dev/audio
device for reading and writing digitized audio.
.SH SEE ALSO
zs(4)
z8(1L)
.SH BUGS
.TP
*
The
STIM occasionally generates false 
.I hangup
signals when an outgoing call is placed.  It is advisable to disable hangup
detection ('l') while placing an outgoing call.
.TP
*
There are several variations of the hardware floating around.  This man page
might describe hardware/software that is different than some of the units.
.SH AUTHOR
S. A. Uhler
