/****************************************************************
Copyright (c) 1993 Bell Communications Research, Inc. (Bellcore)

Permission to use, copy, modify, and distribute this material
for any purpose and without fee is hereby granted, provided
that the above copyright notice and this permission notice
appear in all copies, and that the name of Bellcore not be
used in advertising or publicity pertaining to this
material without the specific, prior written permission
of an authorized representative of Bellcore.  BELLCORE
MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY
OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES.
****************************************************************/

/* macros for accessing audio capabilites */

#define RECORD		0
#define PLAY		1

#ifndef TRUE
#define TRUE	1
#endif

#ifndef FALSE
#define FALSE	0
#endif

#define play_start(fd)		audio_mode(fd,PLAY,FALSE)
#define play_stop(fd)		audio_mode(fd,PLAY,TRUE)
#define record_start(fd)	audio_mode(fd,RECORD,FALSE)
#define record_stop(fd)		audio_mode(fd,RECORD,TRUE)

#define SPS			8000			/* sample rate, samples/second */
#define HUNK		1000			/* bytes to process at one shot (>~0.1 sec)*/
#define R_GAIN    75          /* set record gain (0-255) */

/* WARNING : if the audio output level exceeds .72 Vrms for extended
   periods of time (> 3 sec) at the SPARC audio output connector,
   the CH1817 telephone line interface unit in the STIM
   automatically disables transmission to the outgoing telephone line.
   Extended operation above this level could damage the telephone interface 
   unit. 
*/

#define P_GAIN    75         /* playback gain (0-255) (don't exceed .72 Vrms)*/

/* this is the mu-law theshold for guessing when a phone call is answered
 * when PhoneStation places an outgoing call.
 * Larger values represent quieter thresholds.  The proper value depends on
 * R_GAIN and the ambient noise level of the line.  If the caller needs to 
 * shout in order to get PhoneStation to recongnize the call was answered,
 * Use a smaller value.  If PhoneStation doesn't wait for the call to complete,
 * try a larger value.
 */

#define ANS_THRES		78				/* quiet threshold (smaller is louder) */
