/****************************************************************
Copyright (c) 1993 Bell Communications Research, Inc. (Bellcore)

Permission to use, copy, modify, and distribute this material
for any purpose and without fee is hereby granted, provided
that the above copyright notice and this permission notice
appear in all copies, and that the name of Bellcore not be
used in advertising or publicity pertaining to this
material without the specific, prior written permission
of an authorized representative of Bellcore.  BELLCORE
MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY
OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES.
****************************************************************/

/* macros for accessing phone functions */

#define off_hook(fd)			phone_command(fd,'H')
#define on_hook(fd)			phone_command(fd,'h')
#define dcd_on(fd)			phone_command(fd,'D')
#define dcd_off(fd)			phone_command(fd,'d')
#define dtmf_on(fd)			phone_command(fd,'E')
#define dtmf_off(fd)			phone_command(fd,'e')
#define loop_off(fd)			phone_command(fd,'l')
#define loop_on(fd)			phone_command(fd,'L')
#define announce_on(fd)		phone_command(fd,'I')
#define announce_off(fd)	phone_command(fd,'A')
#define flash_hook(fd)		phone_command(fd,'F')
#define phone_reset(fd)		phone_command(fd,'R')
#define phone_sync(fd)		phone_command(fd,'X')

/* 1/10 second sleep */

#define fsleep() \
   { \
   struct timeval _time; \
   _time.tv_sec = 0; \
   _time.tv_usec = 100000; \
   select(0,0,0,0,&_time); \
   }

/* flags for open_phone */

#define PH_NODELAY	1			/* don't hang on open waiting for DCD */
#define PH_SIGHUP		2			/* send sighup upon disconnect */
#define PH_NOCHECK	4			/* don't check the phone interface */

int is_timer();
void debug_phone();				/* set phone debugging flags */
