/****************************************************************
Copyright (c) 1993 Bell Communications Research, Inc. (Bellcore)

Permission to use, copy, modify, and distribute this material
for any purpose and without fee is hereby granted, provided
that the above copyright notice and this permission notice
appear in all copies, and that the name of Bellcore not be
used in advertising or publicity pertaining to this
material without the specific, prior written permission
of an authorized representative of Bellcore.  BELLCORE
MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY
OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES.
****************************************************************/

/* generate dtmf tones using 2nd order recursion (SAU 10/92) */
/* This code is scheduled for demise (its pretty dumb) SAU 8/93 */

/*	 tone matrix

   679   1    2    3    A
   770   4    5    6    B
   852   7    8    9    C
   941   *    0    #    D

       1209 1336 1447 1633
*/

#include <math.h>
#include <stdio.h>

#define BETWEEN(a,x,b)     ((x)<(a)?a:((x)>(b)?b:x)) 
#ifdef CC_BOTCH
#  define CAT(a,b)		(a/**/b)				/* contatenate (cc) */
#else
#  define CAT(a,b)		(a##b)				/* concatenate (ansi) */
#endif

/* this is really stupid!! */

#define TONE(c,n) \
	(CAT(n,0)=c*CAT(n,1)-CAT(n,2),CAT(n,2)=CAT(n,1),CAT(n,1)=CAT(n,0))

struct coef {
	double k0, kc;		/* coef's for sine wave recursion */
	};

static struct coef k[] = {
	0.5204881302,1.7077378093,	/* 697 */
	0.5685618507,1.6452810360,	/* 770 */
	0.6203267580,1.5686869839, /* 852 */
	0.6735932108,1.4782045682, /* 941 */
	0.8131515578,1.1641040230, /* 1209 */
	0.8670707012,0.9963702107, /* 1336 */
	0.9168163214,0.7986183892, /* 1447 */
	0.9587453470,0.5685327068, /* 1633 */
	};


static char *tones = "123A456B789C*0#D";			/* valid touch tones */

extern unsigned char  *Sb2i;
extern char *index();

/* generate touch tones algorithmically */

int
gen_tone(tone,dur,vol,buff)
char tone;							/* tone to generate */
int dur;								/* duration in samples */
int vol;								/* volume (0-100%) */
char *buff;							/* the output goes here */
	{
	char *s;							/* index into tones */
	int i1,i2;						/* indeces into "K" table */
	double m0, m1, m2;			/* row Queue */
	double n0, n1, n2;			/* column Queue */
	double c1,c2;					/* recursion constants */

	if (!(s=index(tones,tone)))
		return(0);

	i1 = (s-tones)/4;
	i2 = 4+(s-tones)%4;
	n1 = k[i1].k0;
	m1 = k[i2].k0;
	c1 = k[i1].kc;
	c2 = k[i2].kc;
   n2 = m2 = 0.0;
	vol = BETWEEN(1,vol,100);
#ifdef MAIN
	fprintf(stderr,"Tone %c: (%d)/15 %d - %d\n",tone,s-tones,i1,i2);
#endif

	while(dur-->0) {
		TONE(c1,n);
		TONE(c2,m);
		*buff++ = (Sb2i[(int)((n0+m1)*vol*19.0)]);
		}
	return(1);
	}
	
#ifdef MAIN

char buff[2000];

main()
	{
	int c;
	while((c=getchar()) != EOF) {
		if (gen_tone(c,2000,95,buff));
			write(1,buff,2000);
		}
	}
#endif
