/* generate a sine wave (use mu law output) */

#include <math.h>
#include <stdio.h>

#define SPS		8000						/* samples per second */
#define SCALE	500.0					/* scale factor (+-1 * SCALE) */

extern unsigned char  *Sb2i;
extern short I2sb[256];

/* make a sine wave tone generator */

main(argc,argv)
int argc;
char **argv;
	{
	register float n0, n1, n2;			/* 3 samples, n0=current, n2 = 2 past */
	register float c;						/* recursion constant */
	register float freq;					/* frequency (in hz) */
	float scale = SCALE;					/* volume */

	if (argc < 2) {
		fprintf(stderr,"usage: %s <freq> [scale] \n",*argv);
		exit(1);
		}
	
	if (argc > 2)
		scale = atof(argv[2]);

	freq = atof(argv[1]);
	fprintf(stderr,"Frequency is %f hz\n",freq);

	c = 2.0 * cos(2.0 * M_PI * freq / SPS);
	n1 = sin(2.0*M_PI*freq/SPS);
	n2 = 0.0;

	while(1) {
		n0 = c * n1 - n0;
		putchar(Sb2i[(int)(n0*scale)]);
		n2 = n1, n1 = n0;
		}
	}
