/****************************************************************
Copyright (c) 1993 Bell Communications Research, Inc. (Bellcore)

Permission to use, copy, modify, and distribute this material
for any purpose and without fee is hereby granted, provided
that the above copyright notice and this permission notice
appear in all copies, and that the name of Bellcore not be
used in advertising or publicity pertaining to this
material without the specific, prior written permission
of an authorized representative of Bellcore.  BELLCORE
MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY
OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES.
****************************************************************/

/* build a table to scale mu-law audio (S. A. Uhler) */

#include <math.h>
#include <stdio.h>

#define B13ZERO	0x1000      /* zero offset in unsigned 13-bit tables */
#define BETWEEN(a,x,b)	((x)<(a)?(a):((x)>(b)?(b):(x)))

extern unsigned char  Ub2i[];
extern short I2sb[];

int
main(argc,argv)
int argc;
char *argv[];
	{
	double fact;
	double pow();
	int db;
	int i,x;
	int b;

	if (argc<2) {
		fprintf(stderr,"usage: %s <DBm>\n",*argv);
		exit(1);
		}

	db = atoi(argv[1]);
	if (db < -20 || db > 20) {
		fprintf(stderr,"%s: %s is out of range\n",*argv,argv[1]);
		exit(1);
		}
	fact = pow(10., (double) db / 10.);
	printf("/* u-law scaling table: %d db */\n\n",db);
	printf("unsigned char %c_scale_%d[] = {\n\t",
				db>0?'u':'d', db>0?db:-db);

	for(i=0;i<256;i++) {
		b = (int)(I2sb[i]*fact);
		x = Ub2i[BETWEEN(1,b+B13ZERO,8190)];
/*
		fprintf(stderr,"%d -> %d -> %d -> (%d) -> %d\n",
			i,I2sb[i],b,BETWEEN(1,b+B13ZERO,8190),x);
*/
		printf("%d%s",x,(i+1)%16?",":",\n\t");
		}
	printf("};\n");
	return(0);
	}
