/****************************************************************
Copyright (c) 1993 Bell Communications Research, Inc. (Bellcore)

Permission to use, copy, modify, and distribute this material
for any purpose and without fee is hereby granted, provided
that the above copyright notice and this permission notice
appear in all copies, and that the name of Bellcore not be
used in advertising or publicity pertaining to this
material without the specific, prior written permission
of an authorized representative of Bellcore.  BELLCORE
MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY
OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES.
****************************************************************/

/* global definitions (sau) */

#define S(x)		stuff->x		/* short hand */

/* put all globals in one struct */

struct stuff {
	char *debug_list;		/* global debugging flags */
	int phone_fd;			/* fd for telephone */
	int audio_fd;			/* fd of audio device */
	char *db;				/* current database cookie */
	char *or;				/* orator cookie */
	int calls;				/* call number */
	int lineno;				/* current line number */
	char hangup;			/* got a hangup */
	char resume;			/* resume after int */
	};

struct vars {
	char *name;				/* name of the variable */
	char *value;			/* default value */
	};

int error_cmd(Tcl_Interp *interp,char *cmd,char *bad); /* !!proto */
char *print_code(int n); /* !!proto */
void term(int sig);		/* called on SIGINT */ /* !!proto */
int parse_args(char *args[]); /* !!proto */
int is_true(char *str); /* !!proto */
char *get_value(Tcl_Interp *interp, char *name); /* !!proto */
char *save_line(char *s); /* !!proto */
void dprintf(char *level, char *fmt, ...); /* !!proto */
void debug_db(int n); /* !!proto */
char *sprintf();

extern struct stuff stuff_data, *stuff;
extern char *debug_list;					/* list of debug flags */
extern int hangup;							/* set when a hangup occurred */
extern char line[];							/* generic temporary space */

#define TCL_UNWIND		5					/* new return code for TCL */
#define MAXLINE			1024				/* size of temp buffer */
